# Syntaxe des expressions CRON pour la définition des périodes d'abonnement

 Le code à saisir doit respecter la syntaxe : **"mm hh jj MMM JJJ tâche"** où

- **mm** représente les minutes (de 0 à 59)
- **hh** représente l’heure (de 0 à 23)
- **jj** représente le numéro du jour du mois (de 1 à 31)
- **MMM** représente l’abréviation du nom du mois (jan, feb,…) ou le numéro du mois (de 1 à 12)
- **JJJ** représente l’abréviation du nom du jour ou bien le numéro du jour dans la semaine (0 = dimanche, 6 = samedi)


* **&#42;** : signifie à chaque unité (0,1,2,3,4…)
* **5,8** : signifie les unités 5 et 8
* **2-5** : signifie les unités de 2 à 5
* **/3** : signifie toutes les 3 unités (0,3,6,9…)
 
## Exemples de syntaxe
* Tous les jours à 12h : **0 12 &#42;&#42;&#42;**
* Tous les lundis à 22h15 : **15 22 &#42; &#42;1**
* Toutes les heures passées de 15 min : **15 &#42; &#42; &#42; &#42;**
* Tous les premiers du mois à 4h42 : **42 4 1 &#42; &#42;**
* Du 2 au 5 de chaque mois à 10h12 : **12 10 2-5 &#42;&#42;**

---

# Services web et privilèges

 L'accès à un service web dépend du profil du compte connecté. Ainsi par exemple, un utilisateur ayant pour privilège gtf_user, ne peut pas accéder à la ressource 'Workspaces' qui retourne la liste des projets puisqu'un privilège gtf_author est requis.
Le tableau ci-dessous présente les privilèges requis pour pouvoir accéder aux différents services de l'API :

<div class="wy-table-responsive">

<table class="docutils" border="1">
<thead valign="middle" align="center">
  <tr>
    <td style="font-weight: bold;">Service</td>
    <td style="font-weight: bold;">Ressource</td>
    <td style="font-weight: bold;">Privilèges requis</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Catégories</td>
    <td>gtf_user</td>
  <tr>

  <tr>
    <td>GTF</td>
    <td>EmailContexts</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>EmailOptions</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>EmailTemplates</td>
    <td>gtf_author</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>FMEEngines</td>
    <td>gtf_admin</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>GtfEngines</td>
    <td>gtf_admin</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>GTFGroups</td>
    <td>vitis_admin</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Inboxes</td>
    <td>gtf_author</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>License</td>
    <td>gtf_admin</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>MessageClasses</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>MessageClassTypes</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Messages</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Orders</td>
    <td>gtf_author</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>OrderStatutes</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Periods</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Priorities</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Servers</td>
    <td>gtf_admin</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Statistics</td>
    <td>gtf_author</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Subscriptions</td>
    <td>gtf_author</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>SupervisionStatues</td>
    <td>gtf_author</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Surveys</td>
    <td>gtf_author</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>SurveyType</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Tags</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>UserOrders</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>UserSubscriptions</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>UserSurveys</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Versions</td>
    <td>gtf_user</td>
  </tr>

  <tr>
    <td>GTF</td>
    <td>Workspaces</td>
    <td>gtf_author</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>Domains</td>
    <td>vitis_user</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>GenericQuerys</td>
    <td>vitis_user</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>Groups</td>
    <td>vitis_user</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>Logs</td>
    <td>vitis_admn</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>Modes</td>
    <td>vitis_user</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>Phpinfo</td>
    <td>vitis_admin</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>Privileges</td>
    <td>vitis_user</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>Properties</td>
    <td>vitis_user</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>Ressources</td>
    <td>vitis_user</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>Tabs</td>
    <td>vitis_user</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>Users</td>
    <td>vitis_admin</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>Versions</td>
    <td>vitis_user</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>VitisSections</td>
    <td>vitis_user</td>
  </tr>

  <tr>
    <td>Vitis</td>
    <td>WebServices</td>
    <td>vitis_user</td>
  </tr>

</table>
</div>

---

# Liste des contrôles GTF

Nom du contrôle GTF

- [Bouton radio](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#contrôle-gtf-de-type-bouton-radio--contrôle-de-type-bouton-radio)
- [Carte Bing](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md##carte-bing)
- [Carte OSM](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#contrôles-gtf-de-type-carte-osm-carte-bing-et-carte-vmap)
- [Carte vMap](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#carte-vmap)
- [Champ caché](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#contrôle-gtf-de-type-champ-caché)
- [Couleur](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md/#paramètre-publié-de-type-choix-de-couleur---contrôle-de-type-couleur)
- [Curseur](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md)
- [Date et Heure](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#paramètre-publié-de-type-dateheure---contrôle-de-type-date-et-heure)
- [Décimal](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#paramètre-publié-de-type-flottant---contrôle-de-type-décimal)
- [Entier](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#paramètre-publié-de-type-entier---contrôle-de-type-entier)
- [Fichier local ](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#paramètre-publié-de-type-nom-de-fichier-multiple---contrôle-de-type-fichier-local)
- [Interface - Ligne de séparation](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md##contrôle-gtf-de-type-interface---ligne-de-séparation)
- [Label](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#contrôles-gtf-de-type-label)
- [Label Titre](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#contrôles-gtf-de-type-label)
- [Liste](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#gestionnaire-de-sources-de-données)
- [Liste déroulante](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#gestionnaire-de-sources-de-données)
- [Texte en édition 1 ligne](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#paramètre-publié-de-type-répertoire-en-sortie---contrôle-de-type-texte-en-édition-1-ligne)
- [Texte en édition Mot de passe](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#paramètre-publié-de-type-mot-de-passe---contrôle-de-type-texte-en-édition-mot-de-passe)
- [Texte en édition Multiligne](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#paramètre-publié-de-type-texte-multiligne---contrôle-de-type-texte-en-édition---multiligne)
- [Texte en édition URL](../publication_traitements/ajout_projet_fme/gestion_personnalisation_formulaires.md#paramètre-publié-de-type-url---contrôle-de-type-texte-en-édition-url)

---
# Projets FME intégrés

 3 projets FME sont intégrés initialement à GTF : "Admin Export", "Admin Import" et "Vérification des formulaires".
 
## Projet "Admin Export"

Le projet "Admin Export" permet d'exporter des projets FME au format d'échange de gtf : .gex.
On peut exporter 1 à n projets FME.

## Projet "Admin Import"

Le projet Admin-Import permet l'import dans GTF de traitements FME contenus dans un répertoire gex. Un projet FME dans GTF est identifié de façon unique par une clé. Le projet d'import permet, en cas d'import de projet dont la clé est existante en base de données, de choisir que faire de ce dernier :
- Remplacer le projet existant : le projet est mis à jour et son nom, sa clé et son identifiant sont conservés.
- Importer le projet avec une nouvelle clé et un nouveau nom :on ajoute de la sorte un nouveau projet en base.
- Ne pas importer le projet

Un rapport d'import est généré au format HTML. Il indique le nom et la clé du projet importé et le statut de l'import, c'est à dire "Mis à jour dans GTF", "Inséré dans GTF" ou "Non mis à jour dans GTF".

![](../../images/icones/warning.png)  L'import de projets au format gex, issus d'une version antérieure à GTF 2016, ne permet pas la création des formulaires au format json. Directement après avoir importé des projets via "Admin Import", lancer le traitement "Vérification des formulaires" pour permettre la génération des formulaires au format json.

## Projet Vérification des formulaires

Ce traitement permet la vérification et/ou la génération des formulaires des traitements. Les formulaires des traitements importés depuis une version antérieure à GTF 2016 ne sont pas directement créés au format JSON. Ce traitement permet de définir les conditions de génération des formulaires par défaut et des formulaires publiés.
 
Tous les traitements sont parcourus.
 
2 options sont possibles :

- **Ne pas forcer la régénération des formulaires par défaut pour tous les traitements** : ne sont traités que les traitements ne disposant pas de formulaire publié de type subform.json. Leurs formulaires sont donc invalides si le type de formulaire publié indiqué en base est de type 'par défaut', alors les 3 formulaires sont générés.
 Sinon, si le formulaire source indiqué en base est de type 'personnalisé', alors un rapport indique que le traitement est invalide et que l'auteur doit créer lui même le formulaire.
  ![formulaire invalide](../../images/formilaire_invalide_58x43.png)   
 
- **Forcer la régénération des formulaires par défaut pour tous les traitements** : un formulaire par défaut est regénéré pour tous les traitements. Les formulaires par défaut sont publiés si le formulaire en base de données est de type "Défaut". Sinon les formulaires publiés personnalisés sont conservés.
 
En savoir plus sur les formulaires dans GTF.
