# Appel externe

La section "Appel externe" permet l'intégration dans une page HTML d'un formulaire GTF. C'est un moyen de donner accès à un projet GTF depuis une quelconque page web, sans avoir GTF installé sur son poste.
La section "Appel externe" du mode Projet permet de définir la façon dont l'utilisateur final aura accès au formulaire GTF puis génère le code à intégrer directement dans la page html désirée.

L'administrateur définit le type d'accès souhaité au formulaire GTF :
- soit via un bouton intégré dans la page Internet,
- soit via l'insertion telle quelle du formulaire GTF dans la page web.

Il associe ensuite un titre au formulaire et, dans le cas d'un bouton, il spécifie le texte associé au bouton d'accès du formulaire dans le champ "Texte du bouton". La hauteur et largeur du formulaire peuvent également être paramétrées.

![](../../../images/appel_externe.png)

*Appel externe*

## Jetons de connexion

Un jeton agit comme une clé permettant d'accéder à un formulaire GTF. Un jeton ne peut être donné qu'à un utilisateur authentifié.
L'administrateur a la possibilité d'associer à un traitement un jeton privé ou un jeton public permettant l'accès et l'utilisation du formulaire GTF :
- Le jeton public est l'identifiant de connexion du compte public défini au préalable par l'administrateur dans le mode "Configuration".
- Fournir un jeton privé est un moyen de donner accès à un compte de connexion à un traitement GTF particulier. Pour générer une clé privée, l'administrateur saisit le login et mot de passe de l'utilisateur pour lequel il souhaite générer un jeton privé puis définit une date de fin de validité de cette dernière. Après avoir cliqué sur le bouton **Clé privée**, la clé est retournée et intégrée dans le code à utiliser.

![Jeton](../../../images/jeton.png)

## Utilisation de CAPTCHA

Il est possible d'intégrer un captcha au formulaire pour s'assurer que la demande de traitement est bien générée par un être humain et non par un ordinateur.

![](../../../images/icones/warning.png) L'insertion d'un captcha, nécessite l'obtention d'une clé sur le service Web de Google à l'adresse [https://www.google.com/recaptcha/admin](). Une fois la clé obtenue, l'administrateur saisit la clé fournie dans le champ "Clé Recaptcha".

![](../../../images/icones/idea.png) La clé est directement intégrée dans le code généré par GTF. Le motif captcha est généré automatiquement à chaque demande de traitement.  

### Insertion du code généré

Le bouton **Générer le code** retourne le code à copier dans la page HTML permettant d'accéder au formulaire GTF. Le code contient le jeton de connexion défini au préalable (public ou privé), ainsi que le cas échéant la clé captcha.

Exemple de code:
  ![exemple de code](../../../images/0300001B.png)
*Jeton de connexion public / Clé captcha*

Ce code est à insérer directement dans la page HTML à l'emplacement désiré.

L'exemple ci-dessous illustre l'insertion d'une fenêtre de demande de création de gex (traitement administration "admin_export") dans une page HTML :

![exemple](../../../images/widget.png)
