# Gestion et personnalisation des paramètres publiés : travailler dans le studio

La section "Formulaire" du mode "Publication" permet de gérer l’affichage du formulaire de demande de traitement tel qu'il sera affiché lors d’une demande émise par un utilisateur.

Le studio permet de personnaliser graphiquement chaque paramètre publié importé depuis FME, et permet la mise en page générale du formulaire de demande.

![Studio de personnalisation de formulaire](../../../images/studio.png)
*Studio de personnalisation de formulaire*

Le studio de personnalisation des formulaires est composé de quatre fenêtres :
- Une fenêtre centrale de prévisualisation du formulaire. Elle permet de prévisualiser le formulaire tel qu'il sera affiché lors d'une demande de traitement, mais il est possible d'afficher le formulaire JSON ou JavaScript en sélectionnant le type d'affichage désiré en haut de la fenêtre. ![](../../../images/previsualisation.png)
- Une fenêtre des paramètres publiés, à droite de l'écran : elle liste l'ensemble des paramètres publiés du projet et leur ordre d'affichage. Il est possible de modifier l'ordre d'affichage des paramètres ![](../../../images/depalcment_paramètre.png), de les supprimer ![](../../../images/suppression_parametre.png) et en d'en créer de nouveaux  ![](../../../images/ajout_parametre.png) .
- Une fenêtre de définition des paramètres, à gauche en bas de l'écran, qui permet leur édition et configuration.
- Une fenêtre formulaire, en haut à gauche de l'écran, qui permet l'enregistrement, la publication et le nommage de chaque formulaire. Il permet d'afficher le formulaire par défaut, le formulaire publié et le formulaire personnalisé.

## Formulaire par défaut, formulaire personnalisé, formulaire publié

Le formulaire par défaut comporte les paramètres publiés du projet FME. Après visualisation, l'auteur peut choisir de conserver en l'état ce formulaire ou de le personnaliser.

Chaque projet FME chargé dans GTF est stocké dans le répertoire "\workspace" du répertoire d'installation de GTF. Le sous-répertoire "workspace\fme" stocke le projet .fmw et les ressources du projet, et le répertoire "workspace\form" stocke les fichiers de gestion et de personnalisation des formulaires du traitement.

Une fois un projet créé, GTF créé 3 fichiers identiques :

* "DsubForm.json" : formulaire par défaut du traitement, affiché dans le studio lorsque l'on sélectionne le bouton ![défaut](../../../images/bouton_defaut.png)
* "SubForm.json" : formulaire publié par GTF, affiché dans le studio lorsque l'on sélectionne le bouton ![Publié](../../../images/bouton_publie.png)
* "WsubForm.json" : formulaire destiné à être personnalisé, affiché dans le studio lorsque l'on sélectionne le bouton de personnalisation ![Perso](../../../images/bouton_perso.png)

Lors de la publication d'un formulaire personnalisé, le fichier WsubForm est modifié puis écrase le fichier SubForm.

Lors de la création d'un projet, les 3 formulaires par défaut, personnalisé et publié sont identiques. L'auteur d'un projet peut ensuite personnaliser le formulaire par défaut. Il choisit de publier ou pas le formulaire personnalisé.
A tout moment il peut revenir au formulaire par défaut et le publier à nouveau.

 ![](../../../images/icones/warning.png)
En cas de re chargement d'un projet FME, si le formulaire publié est identique au formulaire par défaut alors les 3 formulaires sont écrasés. En revanche, lorsque le formulaire publié est identique au formulaire personnalisé, alors seul le formulaire par défaut est écrasé. Dans ce cas de figure, les formulaires personnalisés et publiés sont donc conservés.

 ![](../../../images/icones/idea.png)
Dans la liste des projets, on peut distinguer les projets publiés exploitant un formulaire par défaut, des projets exploitant un formulaire personnalisé par la couleur du pictogramme du champ Formulaire : un pictogramme vert signifie que le formulaire par défaut est publié. Un pictogramme bleu indique que le formulaire publié est un formulaire personnalisé.
![Liste des projets et formulaires exploités](../../../images/picto_firmulaire.png)
 *Liste des projets et formulaires exploités*

### Création d'onglets dans un formulaire

L'auteur d'un projet peut choisir d'agencer le formulaire de demande de traitement sous forme d'onglets. Il peut ainsi répartir les paramètres sur plusieurs onglets.

Le bouton "Edition" > **Gestion des onglets** de la fenêtre des formulaires personnalisés permet d'accéder à la fenêtre de gestion de ces derniers.

![Gestion des onglets](../../../images/onglets.png)

 ![Studio - Fenêtre de gestion des onglets d'un formulaire](../../../images/onglets2.png)

Après avoir édité et nommé un onglet, cocher les paramètres devant le composer. Le bouton **Ajouter un onglet** en bas de la fenêtre permet la création d'un nouvel onglet.
Un aperçu des onglets nouvellement créés s'affiche dans la partie de droite de la fenêtre.
Cliquer sur **Valider** pour revenir au studio.

![Edition d'onglets](../../../images/onglet_edition.png)

 ![](../../../images/icones/idea.png) Les onglets ne sont pas apparents dans le studio mais uniquement dans la fenêtre de gestion de ces derniers.

  ![](../../../images/icones/warning.png) Un paramètre peut apparaître sur deux onglets différents. Lors de la demande d'un tel projet, l'édition d'un paramètre dans un onglet est automatiquement reportée dans le deuxième onglet.

## Paramètres publiés FME et contrôles GTF

Les paramètres publiés de FME sont importés dans GTF et peuvent être modifiés dans le studio via des contrôles GTF. Un contrôle GTF est converti en paramètre publié FME lors du traitement du projet.
Certains contrôles GTF ne sont pas issus de paramètres publiés de FME et correspondent à des composants de mise en page (interface) destinés à personnaliser l'interface du formulaire de demande de projet.

Il existe 20 types de contrôles GTF paramétrables dans la fenêtre de Définition des Paramètres :

Nom du contrôle GTF

- [Bouton radio](#controle-gtf-de-type-bouton-radio-controle-de-type-bouton-radio)
- [Carte Bing](#carte-bing)
- [Carte OSM](#contrôles-gtf-de-type-carte-osm-carte-bing-et-carte-vmap)
- [Carte vMap](#carte-vmap)
- [Champ caché](#contrôle-gtf-de-type-champ-caché)
- [Couleur](#paramètre-publié-de-type-choix-de-couleur---contrôle-de-type-couleur)
- [Curseur](#paramètre-publié-et-contrôle-de-type-curseur)
- [Date et Heure](#paramètre-publié-de-type-dateheure---contrôle-de-type-date-et-heure)
- [Décimal](#paramètre-publié-de-type-flottant---contrôle-de-type-décimal)
- [Entier](#paramètre-publié-de-type-entier---contrôle-de-type-entier)
- [Fichier local ](#paramètre-publié-de-type-nom-de-fichier-multiple---contrôle-de-type-fichier-local)
- [Interface - Ligne de séparation](#contrôle-gtf-de-type-interface---ligne-de-séparation)
- [Label](#contrôles-gtf-de-type-label)
- [Label Titre](#contrôles-gtf-de-type-label)
- [Liste](#gestionnaire-de-sources-de-données)
- [Liste déroulante](#gestionnaire-de-sources-de-données)
- [Texte en édition 1 ligne](#paramètre-publié-de-type-répertoire-en-sortie---contrôle-de-type-texte-en-édition-1-ligne)
- [Texte en édition Mot de passe](#paramètre-publié-de-type-mot-de-passe---contrôle-de-type-texte-en-édition-mot-de-passe)
- [Texte en édition Multiligne](#paramètre-publié-de-type-texte-multiligne---contrôle-de-type-texte-en-édition---multiligne)
- [Texte en édition URL](#paramètre-publié-de-type-url---contrôle-de-type-texte-en-édition-url)

![](../../../images/icones/warning.png) *Un nom de paramètre ne peut pas contenir d'espace.*

![](../../../images/icones/idea.png) *Les valeurs par défaut d'un paramètre publié FME sont importées dans GTF.*

### Paramètre publié de type "Choix" - Contrôle de type "Liste déroulante"

Un paramètre publié FME de type "Choix" est importé dans un GTF en contrôle de type "Liste déroulante".
La configuration de la liste se fait via le [Gestionnaire de source de données](#gestionnaire-de-sources-de-donnees).
L'auteur du projet nomme le paramètre et son libellé tel qu'il sera affiché dans le formulaire de demande et définit le nombre de lignes. Il indique si le paramètre est obligatoire en cochant ou pas la case "Requis".

Il est possible de faire de cette liste une [liste en cascade](), en définissant la liste parent et les attributs sur lesquels doit reposer l'ascendance.

![](../../../images/choix.png) ![](../../../images/FLECHE.png) ![](../../../images/Cld.png)

*Paramètre publié de type Choix et Contrôle GTF de type Liste déroulante*

### Paramètre publié de type "Choix multiple" - Contrôle de type "Liste"

Un paramètre publié FME de type Choix multiple est importé dans GTF en contrôle de type Liste. Le [Gestionnaire de source de données]() permet de configurer la liste importée.

L'auteur du projet nomme le paramètre et le libellé tel qu'il sera affiché dans le formulaire de demande et définit la valeur par défaut. Il paramètre le nombre de lignes à afficher. Il définit si le paramètre est obligatoire en cochant ou pas la case "Requis".

![](../../../images/choix_multi.png)

 ![](../../../images/FLECHE.png) ![](../../../images/c_liste.png)

*Paramètre publié de type Choix multiple et contrôle GTF de Type Liste*

Il est possible de faire de cette liste une [liste en cascade](), en définissant la liste parent et les attributs sur lesquels doit reposer l'ascendance.

### Paramètre publié de type "Choix avec alias" - Contrôle de type "Liste déroulante"

Un paramètre publié de type "Choix avec alias" est importé dans GTF en contrôle de type "Liste déroulante".
La configuration de la liste se fait dans le Gestionnaire de source de données.
L'auteur du projet nomme le paramètre et son libellé tel qu'il sera affiché dans le formulaire de demande et définit sa valeur par défaut. Il paramètre le nombre de lignes à afficher. Il définit si le paramètre est obligatoire en cochant ou pas la case "Requis".

![](../../../images/param_choix_alias.png) ![](../../../images/FLECHE.png) ![](../../../images/liste_deroulante_alias.png)

*Paramètre publié de type Choix avec alias et Contrôle GTF de type Liste déroulante.*

Il est possible de faire de cette liste une [liste en cascade](), en définissant la liste parent et les attributs sur lesquels doit reposer l'ascendance.

### Paramètre publié de type "Choix avec alias multiple" - Contrôle de type "Liste"

Un paramètre pubié de type "Choix avec alias multiple" est importé dans GTF en contrôle de type "Liste".
La configuration de la liste se fait dans le
[Gestionnaire de source de données]().
L'auteur du projet nomme le paramètre et le libellé qui sera affiché dans le formulaire de demande, définit le nombre de lignes à afficher. Il définit si le paramètre est obligatoire en cochant ou pas la case "Requis".

![](../../../images/parma_alias_multi.png) ![](../../../images/FLECHE.png) ![](../../../images/choixaliasmultpile.png)

*Paramètre publié de type Choix avec alias multiple et contrôle GTF de type Liste*

Il est possible de faire de cette liste une [liste en cascade](), en définissant la liste parent et les attributs sur lesquels doit reposer l'ascendance.


### Paramètre publié de type "Choix de couleur" - Contrôle de type "Couleur"

Un paramètre publié de tye "Choix de couleur" est importé dans GTF en contrôle de type "Couleur" . L'auteur nomme le paramètre et le libellé qui sera affiché dans le formulaire de demande, définit la couleur par défaut. Il peut choisir la largeur du contrôle et définir si ce paramètre est obligatoire ou pas.

![](../../../images/couleur_fond.png) ![](../../../images/FLECHE.png) ![](../../../images/c_couleur.png)

### Paramètre publié et contrôle de type "Curseur"

Un paramètre publié de type "Curseur" est importé sous la forme de contrôle de type "Curseur". L'auteur du projet nomme le paramètre et le libellé tel qu'il sera affiché dans le formulaire de demande et définit les valeurs minimales et maximales ainsi que la valeur par défaut du curseur.

![](../../../images/curseur.png) ![](../../../images/FLECHE.png) ![](../../../images/c_curseur.png)

### Paramètre publié de type "Date/heure" - Contrôle de type "Date et Heure"

Un paramètre publié de type "Date/Heure" est importé dans GTF sous la forme de contrôle "Date et Heure".
L'auteur nomme le paramètre et le libellé qui sera affiché dans le formulaire de demande. Il peut définir la date et heure affichées par défaut. Il définit si le paramètre est obligatoire en cochant ou pas la case "Requis".

![](../../../images/p_date.png) ![](../../../images/FLECHE.png) ![](../../../images/c_date.png)

### Paramètre publié de type "Entier" - Contrôle de type "Entier"

Un paramètre publié de type "Entier" est importé dans GTF en contrôle de type "Entier". L'auteur nomme le paramètre et le libellé qui sera affiché dans le formulaire de demande et définit la valeur par défaut . Il peut définir si ce paramètre est obligatoire ou pas en cochant la case "Requis".

![](../../../images/f_param_entier.png) ![](../../../images/FLECHE.png) ![](../../../images/c_entier.png)

*Paramètre publié et contrôle de type "Entier"*

### Paramètre publié de type "Flottant" - Contrôle de type "Décimal"

Un paramètre publié de type "Flottant" est importé dans GTF en contrôle de type "Décimal". L'auteur nomme le paramètre et le libellé qui sera affiché dans le formulaire de demande et définit la valeur par défaut. Il peut définir si ce paramètre est obligatoire ou pas en cochant la case "Requis".

![](../../../images/param_pub_flottant.png) ![](../../../images/FLECHE.png) ![](../../../images/c_float.png)

*Paramètre publié de type "Flottant" et contrôle de type "Décimal"*

### Paramètre publié de type "Mot de passe" - Contrôle de type "Texte en édition mot de passe"

Un paramètre publié FME de type "Mot de passe "est importé dans GTF sous la forme de contrôle de type "Texte en édition - mot de passe".
L'auteur nomme le paramètre et le libellé qui sera affiché dans le formulaire de demande.
Il peut définir un motif sous la forme d'expression régulière, pour contrôler l'affichage du mot de passe et s'assurer que la valeur respecte bien un modèle.
Il peut définir si ce paramètre est obligatoire ou pas en cochant la case "Requis", et choisit la largeur du contrôle.

![](../../../images/pwd.png) ![](../../../images/FLECHE.png) ![](../../../images/c-pwd.png)

*Paramètre publié de type "Mot de passe" et Contrôle de type "Texte en édition - mot de passe"*

### Paramètre publié de type "Nom de fichier multiple" - Contrôle de type "Fichier Local"

Un paramètre publié FME de type "Nom de fichier (Multiple)" est importé dans GTF sous la forme de contrôle de type "Fichier Local".
L'auteur du projet nomme le paramètre et le libellé qui sera affiché dans le formulaire de demande, définit la largeur du contrôle et indique si le paramètre est obligatoire ou pas.

![](../../../images/param_p_fichiers_multi.png) ![](../../../images/FLECHE.png) ![](../../../images/c_fichier_sources.png)

*Paramètre publié de type "Nom de fichier Multiple" et Contrôle de type "Fichier local"*

#### Options avancées

Les options avancées permettent d'affiner l'affichage du formulaire lors du chargement de fichiers en faisant apparaître ou pas la prévisualisation des fichiers, ainsi que les boutons de chargement et de suppression des fichiers.

### Paramètre de type "Nom de fichier en sortie" - Contrôle de type "Fichier Local"

Le paramètre publié de type "Fichier en sortie" est importé sous la forme de contrôle de type "Texte en édition - 1 ligne". L'auteur du projet nomme le paramètre et définit le libellé tel qu'il sera affiché dans le formulaire de demande. Il peut insérer une expression régulière dans le champ "Motif" pour assurer un contrôle de la valeur saisie. Il peut définir une valeur par défaut, la largeur du contrôle à afficher et indique si le paramètre est obligatoire ou pas.

![](../../../images/param_p_fichiers_multi.png) ![](../../../images/FLECHE.png) ![](../../../images/c_fichier_sources.png)

*Paramètre publié de type "Nom de fichier en sortie" et Contrôle GTF de type "Texte en édition" - 1 ligne*

### Paramètre publié de type "Nom de système de coordonnées" - Contrôle de type "Liste déroulante"

Un paramètre publié de type "Nom de Système de coordonnées" est importé dans GTF sous la forme d'une "Liste déroulante". Les valeurs de la liste sont automatiquement importées et visibles dans le gestionnaires de source de données.

![](../../../images/param_pub_sys_coord.png) ![](../../../images/FLECHE.png) ![](../../../images/c_syst_coord.png)

*Paramètre publié de type "Nom de système de coordonnées" et Contrôle de type "Liste déroulante".*

La configuration de la liste se fait via le [Gestionnaire de source de données]().
L'auteur du projet nomme le paramètre et le libellé qui sera affiché dans le formulaire de demande et définit le nombre de lignes à afficher ainsi que la largeur du contrôle. Il indique si le paramètre est obligatoire en cochant ou pas la case "Requis".

### Paramètre publié de type "Répertoire existant" - Contrôle de type "Fichier local"

Un paramètre publié de type "Répertoire existant" est importé sous la forme d'un contrôle de type "Fichier local". L'auteur du projet nomme le paramètre et le libellé tel qu'il sera affiché dans le formulaire de demande, il définit la largeur du contrôle et indique si ce paramètre est obligatoire ou pas.

Les [options avancées]() permettent d'affiner les paramètres d'affichage lors du téléchargement du fichier.

![](../../../images/f_rep_existant.png) ![](../../../images/FLECHE.png) ![](../../../images/c_rep_ex.png)

*Paramètre publié de type "Répertoire (Existant)" et contrôle de type "Fichier Local"*

### Paramètre publié de type Répertoire en sortie - Contrôle de type Texte en édition 1 ligne

Un paramètre publié de type "Répertoire" en sortie est importé sous la forme d'un contrôle de type "Texte en édition 1 ligne". L'auteur du projet nomme le paramètre et le libellé tel qu'il sera affiché dans le formulaire de demande. Il peut définir la valeur par défaut du nom de répertoire à créer, et il peut saisir une expression régulière dans le champ "Motif" pour assurer un contrôle du nom créé.
Il peut définir la largeur du contrôle et indiquer si le paramètre est obligatoire en cochant ou pas la case "Requis".

![](../../../images/f_repSortie.png) ![](../../../images/FLECHE.png) ![](../../../images/c_txt_1l.png)

*Paramètre publié de type Répertoire en sortie et contrôle de type Texte en édition- 1 ligne*

### Paramètre publié de type "Texte" - Contrôle de type "Texte en édition 1 ligne"

Un paramètre publié de type "Texte" est importé sous la forme d'un contrôle de type "Texte en édition- 1 ligne". L'auteur du projet nomme le paramètre et le libellé tel qu'il sera affiché dans le formulaire de demande. Il peut définir la valeur par défaut à créer, et peut saisir une expression régulière dans le champ "Motif" pour assurer un contrôle de la valeur saisie.
Il peut définir la largeur du contrôle et indiquer si le paramètre est obligatoire en cochant ou pas la case "Requis".

![](../../../images/f_p_txt.png) ![](../../../images/FLECHE.png) ![](../../../images/c_txt_1l_2.png)

*Paramètre publié de type "Texte" et Contrôle GTF de type "Texte en édition - 1 ligne"*

### Paramètre publié de type "Texte multiligne" - Contrôle de type "Texte en édition - Multiligne"

Un paramètre publié de type "Texte multiligne" est importé sous la forme d'un contrôle de type "Texte en édition-multiligne". L'auteur du projet nomme le paramètre et le libellé tel qu'il sera affiché dans le formulaire de demande. Il peut définir la valeur par défaut et la largeur du contrôle et indiquer si le paramètre est obligatoire en cochant ou pas la case "Requis".

![](../../../images/f_multlignesss.png) ![](../../../images/FLECHE.png) ![](../../../images/c_txt_multi.png)

*Paramètre publié de type "Texte multiligne" et contrôle de type "Texte en édition - Multiligne"*

### Paramètre publié de type "Texte Multiligne ou Nombre" - Contrôle de type "Texte en édition - Multiligne"

Un paramètre publié de type "Texte Multiligne ou Nombre" est importé sous la forme d'un contrôle de type Texte en édition-Multiligne. L'auteur du projet nomme le paramètre et le libellé tel qu'il sera affiché dans le formulaire de demande. Il peut définir la valeur par défaut et la largeur du contrôle et indiquer si le paramètre est obligatoire en cochant ou pas la case "Requis".

![](../../../images/f_txt_multi.png) ![](../../../images/FLECHE.png) ![](../../../images/c_txt_multi.png)

*Paramètre publié de type Texte multiligne ou Nombre et contrôle de type Texte en édition - Multiligne*

#### Paramètre publié de type "URL" - Contrôle de type "Texte en édition URL"

Un paramètre publié de type "URL" est importé sous la forme d'un contrôle de type "Texte en édition-URL". L'auteur du projet nomme le paramètre et le libellé tel qu'il sera affiché dans le formulaire de demande. Il peut insérer un motif via une expression régulière pour assurer un contrôle sur la valeur saisie (type de protocole spécifique), définir la valeur par défaut et la largeur du contrôle et indiquer si le paramètre est obligatoire en cochant ou pas la case "Requis"

![](../../../images/f_url.png) ![](../../../images/FLECHE.png) ![](../../../images/c_url.png)

*Paramètre publié de type "URL" et contrôle de type "Texte en édition - URL"*

### Contrôle GTF de type "Bouton radio" - Contrôle de type "Bouton Radio"

Un paramètre publié FME de type "Choix" est importé dans GTF en tant que contrôle de type "Liste Déroulante", mais il est possible de modifier ce dernier en exploitant un contrôle de type "Bouton radio".
L'auteur du projet nomme le paramètre et son libellé tel qu'il sera affiché dans le formulaire de demande.
Il définit la valeur par défaut et détermine si les boutons radios seront désactivés ou pas. Il définit ensuite les options possibles en entrant le libellé du bouton et la valeur envoyée en base.
Le bouton ![](../../../images/b_radio_options.png) permet de rajouter des boutons au paramètre.

![](../../../images/b_radio.png) ![](../../../images/FLECHE.png) ![](../../../images/f_b_radio.png)

*Contrôle de type "Bouton Radio"*

### Contrôles GTF de type "Carte OSM", "Carte Bing" et "Carte vMap"

GTFpermet d'exploiter les services web OSM, Bing Maps ou Vitis vMap pour personnaliser un formulaire en exploitant leurs ressources cartographiques.
Par exemple, dans FME, on peut définir une géométrie dans un champ de type texte définie par une chaîne de caractère WKT.
Dans GTF, Il est plus simple de personnaliser le formulaire de saisie  en exploitant une carte OSM comme support de saisie de la géométrie plutôt que de rentrer une chaîne WKT dans un contrôle de type "Texte".

#### Carte OSM

L'auteur du projet qui insère un élément (ou qui modifie un paramètre existant) de type "Carte OSM", nomme le paramètre, et définit le libellé qui sera affiché dans le formulaire de demande. Il définit la hauteur et la largeur de la carte et indique si ce paramètre est obligatoire ou pas en cochant la case "Requis".

![](/images/c_osm.png)

Il définit ensuite les options spécifiques aux éléments de type carte :

![](../../../images/carte_outils.png)

- La projection de la carte : WGS84 ou Lambert 93. En Lambert 93, l’étendue par défaut correspond à l'ensemble de la France métropolitaine.
- Méthode de centrage de la carte : l'auteur choisit si le centre de la carte est défini par un point défini via des coordonnées X/Y et une échelle d'affichage, ou si le centre de la carte est paramétrée par son étendue définie par les coordonnées X et Y Min et Max.

L'auteur choisit ensuite les éléments de dessin et de navigation qui seront affichés sur la carte du formulaire de demande :
- Position de la souris : affichage dynamique des coordonnées de la souris selon la projection définie.
- Boutons de zoom : affichage des boutons de navigation classique zoom avant, zoom arrière et retour à l'étendue par défaut.
- Echelle : affichage de l'échelle.
- Projection de la carte : affichage de la projection Lambert 93 ou WGS 84.
- Multiples géométries : possibilité ou pas de saisir des géométries de type différent (point, ligne et polygone).
- Plein écran : permet d'afficher la carte en mode plein écran.
- Suppression générale : suppression de toutes les géométries saisies sur la carte.
- Edition : modification de la géométrie sélectionnée.
- Dessiner un point.
- Dessiner une ligne.
- Dessiner un polygone.

Le champ "Valeur" permet à l'auteur de définir une géométrie qui sera affichée par défaut dans le formulaire de demande. Cette géométrie est décrite via une chaîne WKT.

![](../../../images/carte_valeur_par_dafaut.png)

*Contrôle "Carte OSM". Exemple de valeur par défaut*

![](../../../images/c_formulaire_carteOSM.png)

*Formulaire de demande d'un contrôle de type "Carte OSM" - Géométrie saisie par défaut*

##### Carte Bing
Tous les paramètres de personnalisation d'une carte Bing Maps sont identiques à ceux des cartes OSM. Il faut fournir en plus, une clé d'accès pour pouvoir exploiter ce service web cartographique.

Générer une clé Bing Maps sur le site https://www.bingmapsportal.com/
Une fois obtenue, entrer la clé dans le champs "Clé" et sélectionner la carte à afficher dans le formulaire de demande :
- Aerial
- Aerial WithLabels
- Road

![](../../../images/carteBing_valeur.png)

![](../../../images/formulaire_carte_bing.png)

*Formulaire de demande de traitement avec contrôle de type "Carte Bing".*

##### Carte vMap
Pour pouvoir exploiter une carte vMap dans GTF, Il faut au préalable, dans vMap, exporter la définition de la carte. L'export d'une carte vMap génère un fichier map.json que l'auteur du formulaire doit télécharger (champ "Fichier local") pour pouvoir l'intégrer dans un formulaire. Il procède ensuite de la même façon qu'avec les autres ressources de type carte, en nommant le paramètre et son libellé, puis en paramétrant l'affichage des [outils propres aux cartes]().

![](../../../images/c_vmap.png)

![](../../../images/c_vmap2.png)

*Formulaire de demande de traitement avec contrôle de type "Carte vMap".*

### Contrôle GTF de type "Interface" - "Ligne de séparation"

Un contrôle de type Interface-Ligne de séparation permet d'améliorer l'affichage d'un formulaire de demande d'un traitement en y insérant des lignes et accroître de la sorte son organisation et sa lisibilité.


### Contrôles GTF de type "Label"

Il existe 2 contrôles de type Label :

#### Label

Un contrôle GTF de type Label permet d'insérer un champ et sa valeur dans un formulaire de demande de projet, sans qu'il puisse être modifié. L'auteur nomme le paramètre et son libellé tel qu'il sera affiché dans le formulaire. Il définit ensuite la valeur à afficher, ainsi que la largeur du contrôle.

#### Label - Style titre

Un contrôle "Label Style Titre" permet d'insérer un titre dans le formulaire de demande. L'auteur définit le nom du paramètre et son libellé, puis définit la classe html à associer au titre.

### Contrôle GTF de type "Champ caché"

Un contrôle GTF de type "Champ caché" permet de masquer un paramètre publié. Le paramètre est exploité dans le traitement mais n'est pas apparent.
L'auteur nomme le paramètre et définit la valeur à exploiter.

 ![](../../../images/icones/idea.png) Un paramètre publié FME caché, c'est-à-dire que son nom est par préfixé par H_, est directement importé dans GTF en contrôle de type Champ caché.

 ![](../../../images/f_champs_cache.png) ![](../../../images/FLECHE.png) ![](../../../images/c_champs_cache.png)

 *Contrôle de type "Champ caché"*

### Gestionnaire de sources de données

Le gestionnaire de sources de données permet la création, l’édition et la suppression des sources de données à associer aux contrôles GTF de type
"Liste" et "Liste déroulante"

Le Gestionnaire de sources de données permet d'exploiter des données :
* Texte : valeurs saisies directement dans le gestionnaire ou importées depuis un paramètre FME de type Choix.
* Valeurs de table locale : valeurs issues d'une table de base de données installée sur le même serveur que GTF.
* Base de données externe : valeurs importées d'une table de base de données externe à GTF.
* Service web Vitis : permet d'exploiter un service web pour en récupérer les ressources.

Le gestionnaire de source de données est accessible en cliquant sur le bouton ![](../../../images/boutonSource_de_donnees.png) en bas à droite de la fenêtre des paramètres publiés.

![](../../../images/Gestionnaire_source_donnees.png)

*Fenêtre du Gestionnaire de source de données*

On peut ajouter, éditer ou supprimer une source de données.
Le bouton 'Ajouter' permet de créer une nouvelle source de données.
Le type de source détermine les paramètres de connexion devant être définis pour pouvoir importer les valeurs.

##### Ajout de source de données de type texte

Cette option permet de saisir directement des valeurs de type texte qui s'afficheront dans le formulaire sous forme de liste déroulante.

##### Paramétrer la source de données

![](../../../images/GSD_texte.png)

*Gestionnaire de source de données. Source de données de type Texte.*

Après avoir nommé la source de données, saisir les libellés et les clés (stockées en base) séparés par le caractère |.
Le bouton 'Aperçu', permet de visualiser la liste en cours de création.
Le bouton 'Valider' permet de valider la création de la liste, de fermer la fenêtre en cours et de revenir à la liste des sources de données.
Cliquer à nouveau sur 'Valider' pour fermer le gestionnaire de source de données et revenir au studio.

##### Lier la source de données au paramètre publié

Pour associer la source de données créée à un paramètre de type liste , sélectionner le paramètre dans la fenêtre Paramètres publiés, puis l'éditer dans la fenêtre de Définition.

![](../../../images/arr.png)

*Sélection du paramètre publié dans le studio.*

Sélectionner ensuite la source de données nouvellement créée dans le champs Source de données :

![](../../../images/selection_source_donnees.png)

*Sélection de la source de données.*

Cliquer ensuite sur le bouton 'Recharger les sources de données ![](../../../images/bouton_recharger.png)  en haut à droite de la fenêtre de prévisualisation, pour pouvoir visualiser la liste.

Vous pouvez paramétrer le nombre de lignes à afficher dans la liste, sa largeur et définir si ce paramètre est obligatoire ou pas, en cochant le paramètre 'Requis'.

##### Ajout d'une source de données de type Valeurs d'une table locale

Le Gestionnaire de source de données permet d'importer les valeurs d'une table de base de données installée sur le même serveur que GTF.

##### Paramétrer la source de données

![](../../../images/GSD_tablelocale.png)

*Gestionnaire de source de données. Source de données de type Valeurs de table locale.*

Saisir le nom à attribuer à la source de données à créer, puis la base de données (facultatif). Appuyer sur le bouton Schémas pour obtenir la liste des schémas de la base, puis sur le bouton Tables pour sélectionner celles contenant les valeurs à utiliser. Le bouton ' Test' permet de tester la connexion en affichant la table dans la fenêtre Aperçu.

Il est possible de filtrer les données à importer via une clause de type Where, définie dans le champs 'Filtre'. Dans l'exemple ci-dessus, on peut choisir de n'afficher que les bâtiments d'une commune et saisir dans le champs filtre la clause : id_com='340003'.

Le bouton 'Valider' permet de fermer la fenêtre en cours et de revenir à liste des sources de données.
Cliquer à nouveau sur Valider pour fermer le gestionnaire de source de données et revenir au studio.

##### Lier la source de données au paramètre publié

Pour lier cette liste à un paramètre publié, sélectionner le paramètre désiré dans la fenêtre des Paramètres publiés à droite de l'écran, pour pouvoir ensuite l'éditer dans la fenêtre de Définition :

![](../../../images/c_table_locale.png)

*Sélection de la source de données.*

Nommer le paramètre, éditer son libellé puis sélectionner dans la liste déroulante la source de données nouvellement créée, dans l'exemple ci-dessus : 'liste_moteurs".

Définir ensuite la clé ainsi que le libellé qui sera affiché dans le formulaire : pour cela cliquer sur le bouton ![](../../../images/bouton_recharger.png) pour charger les valeurs et sélectionner celles à définir comme clé puis comme libellé :

![](../../../images/c_chargement_cle_libelle.png)

*Définition de l'attribut clé.*

Dans la fenêtre de prévisualisation, cliquer ensuite sur le bouton 'Recharger les sources de données' ![Recharger](../../../images/bouton_recharger.png), pour pouvoir prévisualiser la liste, telle qu'elle s'affichera dans le formulaire de demande :

![](../../../images/formulaire_demande_liste.png)

*Prévisualisation du paramètre de type Liste.*

Vous pouvez paramétrer le nombre de lignes à afficher dans la liste, sa largeur et définir si ce paramètre est obligatoire ou pas, en cochant le paramètre 'Requis'.

Vous pouvez faire de cette liste une [liste en cascade]() en cochant la case Cascade.

![](../../../images/cascade.png)

##### Options avancées = affiner l'affichage des listes

Il est possible d'affiner l'affichage des éléments de la liste via des commandes de tri (order_by et sort_order) sur les attributs dont on spécifie les noms dans le champs Attributs. Ils doivent êtres séparés par le caractère |. Pour distinguer les valeurs identiques, on peut définir une clause distinct.
On peut également filtrer les valeurs à afficher via une clause Where dont on spécifie les arguments dans le champ ' filter'. Dans l'exemple ci-dessous, on choisit de n'afficher que le moteur n° 1 en insérant une clause Where sur l'attribut gtf_engine_id :

![](../../../images/c_options_avancees.png
Ajout d'une source de données de type Base de données externe

##### GTF permet d'importer des valeurs d'une table de base de données externe.

##### Paramétrer la source de données

![](../../../images/GSD_externe.png)

* Gestionnaire de source de données. Source de données de type Base de données externe.

Après avoir saisi le nom de la nouvelle source de données, saisir les paramètres de connexion à la base de données (serveur, port, sgbd, login, mot de passe et tables). Le bouton ![bouton table](../../../images/bouton_tables.png) permet d'afficher la liste des tables de la base et de la sorte de s'assurer de la réussite de la connexion.
Il est également possible de filtrer les données à importer via une clause de type Where, saisie dans le champs Filtre.
Dans l'exemple ci-dessus, seuls les ESI en instruction et inscrits seront listés dans le formulaire.

Le bouton 'Valider' permet de fermer la fenêtre en cours et revenir à liste des sources de données.
Cliquer, à nouveau, sur Valider pour fermer le gestionnaire de source de données et revenir au studio.

##### Lier la source de données au paramètre publié

Pour lier cette liste à un paramètre publié, sélectionner le paramètre désiré dans la fenêtre des Paramètres publiés à droite de l'écran, pour pouvoir ensuite l'éditer dans la fenêtre de Définition :

![](../../../images/liste_esi.png)

Nommer le paramètre, éditer son libellé puis sélectionner dans la liste déroulante la source de données nouvellement créée, dans l'exemple ci-dessus : 'esi'.

Définir ensuite la clé ainsi que le libellé : pour cela, cliquer sur le bouton ![Recharger](../../../images/bouton_recharger.png) pour charger les valeurs et sélectionner celles à définir comme clé puis comme libellé :

![](../../../images/esi_cle.png)
![Recharger](../../../images/bouton_recharger.png)
Cliquer ensuite sur le bouton 'Recharger les sources de données' ![Recharger](../../../images/bouton_recharger.png) dans la fenêtre de prévisualisation, pour pouvoir prévisualiser la liste, telle qu'elle s'affichera dans le formulaire de demande :

![](../../../images/esi_previsualisation.png)

Vous pouvez paramétrer le nombre de lignes à afficher dans la liste, sa largeur et définir si ce paramètre est obligatoire ou pas, en cochant le paramètre 'Requis'.

Vous pouvez faire de cette liste une [liste en cascade]() en cochant la case Cascade.

![](../../../images/cascade.png)

##### Options avancées

##### Ajout d'une source de données de type Service web

Il est possible d'exploiter les ressources des services web Vitis et Gtf pour configurer les paramètres de type liste.

![](../../../images/GSD_services.png)

* Gestionnaire de source de données. Source de données de type Service Web.*

Après avoir sélectionné le service à exploiter (Vitis ou Gtf), sélectionner la ressource dont vous voulez importer les données.
Dans l'exemple ci-dessus, on exploite la ressource Groups du service Vitis. Les groupes d'utilisateurs de Vitis seront importés dans le paramètre publié de type liste, en cours de création.

![](../../../images/attention.png) *L’accès aux services web diffère selon les privilèges liés à l’utilisateur. Il faut donc s'assurer que le compte connecté ait bien les droits requis pour accéder au service web de son choix. Consulter la liste des droits par service.*

Le bouton 'Valider' permet de fermer la fenêtre en cours et revenir à liste des sources de données.
Cliquer à nouveau sur Valider pour fermer le gestionnaire de source de données et revenir au studio.

##### Lier la source de données au paramètre publié

Pour lier cette liste à un paramètre publié, sélectionner le paramètre désiré dans la fenêtre des Paramètres publiés à droite de l'écran, pour pouvoir ensuite l'éditer dans la fenêtre de Définition :

![](../../../images/c_service_web.png)

Nommer le paramètre, éditer son libellé puis sélectionner dans la liste déroulante la source de données nouvellement créée, dans l'exemple ci-dessus : 'groupes'.
Définir ensuite la clé ainsi que le libellé. Pour cela cliquer sur le bouton ![Recharger](../../../images/bouton_recharger.png) pour charger les valeurs et sélectionner celles à définir comme clé puis comme libellé :

![](../../../images/sw_cle_libelle.png)

Cliquer ensuite sur le bouton 'Recharger les sources de données' ![Recharger](../../../images/bouton_recharger.png) dans la fenêtre de prévisualisation, pour pouvoir visualiser la liste, telle qu'elle s'affichera dans le formulaire de demande :

![](../../../images/sw_previsualisation.png)

Vous pouvez paramétrer le nombre de lignes à afficher dans la liste, sa largeur et définir si ce paramètre est obligatoire ou pas, en cochant le paramètre 'Requis'.

Vous pouvez faire de cette liste une [liste en cascade]() en cochant la case cascade.

#### Options avancées

#### Créer des listes en cascade

On peut choisir d'afficher une liste dont le contenu varie en fonction des valeurs sélectionnées dans une autre liste. L'option Cascade permet le paramétrage de telles listes en spécifiant le paramètre publié parent et l'attribut enfant sur lequel effectuer le filtre d'affichage.

**Attributs de filtrage et Signe de comparaison**
Après avoir défini quel est l'élément parent, il faut définir le champ enfant sur lequel repose l'ascendance ainsi que le signe de comparaison sur lequel doit reposer la comparaison entre les champs liant la table parent à la table enfant.
Les signes de comparaison sont :
- = Egalité parfaite entre le champ parent et le champ enfant
- \> Ne seront affichés dans la liste enfant que les enregistrements dont la valeur est supérieure à l'attribut de filtre parent.
- < Ne seront affichés dans la liste enfant que les enregistrements dont la valeur est inférieure à l'attribut de filtre parent.

**Attendre le parent**
Pour forcer l'affichage de la liste des éléments enfants uniquement lorsqu'un élément parent est sélectionné, il faut cocher la case 'Attendre le parent'. Ainsi, si aucun élément parent n'est sélectionné, aucun élément enfant n'apparaîtra dans la liste.

**Exemple**
On veut faire apparaître les sections d'une commune sélectionnée préalablement.
Un premier paramètre nommé 'commune' est créé. Il exploite les valeurs d'une table 'commune' d'une base de données. Un deuxième paramètre nommé 'section' est créé. Il exploite les valeurs d'une table 'section' de la même base.
Dans la fenêtre de la définition du paramètre 'section', après avoir lié le paramètre à la source de données, sélectionner la boîte à cocher 'cascade' puis sélectionner le paramètre parent 'commune' :

![](../../../images/cascade.png)

Seules les 2 sections de la commune sélectionnée d'Abeilhan apparaissent désormais dans la liste Section :

![](../../../images/cascade2.png)
