# Modèles d'E-mail

L'onglet Modèles-email du mode Publication permet la création de modèles d'e-mails envoyés après exécution d'un traitement. Via cette onglet, l'administrateur (ou l'auteur) a la possibilité de personnaliser un e-mail, en définissant la ou les personnes destinataires, les circonstances d'envoi de ce dernier ainsi que son contenu. Il choisit ensuite pour chaque modèle, la définition à utiliser.

Chaque traitement est associé à un modèle d'e-mail.

L'onglet Informations générales permet de créer un nouveau modèle de mail, en le nommant et en définissant son contexte à GTF et de définir le type de définition de ce dernier :

## Définition simple

L'administrateur exploite les balises disponibles pour personnaliser le corps du mail.

<div class="wy-table-responsive">

<table class="docutils" border="1"><colgroup><col width="20%"> <col width="20%"> <col width="19%"> <col width="19%"> <col width="22%"></colgroup>

<thead valign="bottom">

<tr class="row-odd">
  <th class="head">Nom de la balise</th>
  <th class="head">Descriptif</th>
  <th class="head">Code correspondant</th>
</tr>

</thead>

<tbody valign="top">
  <tr class="row-even">
    <td>[order.order_id]</td>
    <td>Identifiant de la demande de traitement</td>
    <td>$properties['order.order_id']['value'] = $this->aObjects["oOrder"]->aFields['order_id'];</td>
  </tr>

  <tr class="row-odd">
    <td>[order.order_date]</td>
    <td>Date et heure de la demande de traitement</td>
    <td>$properties['order.order_date']['value'] = $this->aObjects["oOrder"]->aFields['order_date'];</td>
  </tr>

  <tr class="row-even">
    <td>[order.execution_date]</td>
    <td>Date et heure de fin de traitement</td>
    <td>$properties['order.execution_date']['value'] = $this->aObjects["oOrder"]->aFields['order_execution_date'];</td>
  </tr>

  <tr class="row-odd">
    <td>[order.result_url]</td>
    <td>Adresse de téléchargement du résultat du traitement</td>
    <td>$properties['order.result_url']['value'] = $this->aObjects["oOrder"]->aFields['result_url'];</td>
  </tr>

  <tr class="row-even">
    <td>[order.log_url]</td>
    <td>Adresse du log du traitement </td>
    <td>$properties['order.order_log']['value'] = $this->aObjects["oOrder"]->aFields[log_url'];</td>
  </tr>

  <tr class="row-odd">
    <td>[order.length_sec]</td>
    <td>Durée du traitement en secondes</td>
    <td>$properties['order.length_sec']['value'] = $this->aObjects["oOrder"]->aFields[length_sec'];</td>
  </tr>

  <tr class="row-even">
    <td> [order.email_notifications] </td>
    <td>Adresse Email du destinataire en copie de mail</td>
    <td>$properties['user.email']['value'] = $this->aObjects["oOrder"]->getUser()->aFields['email'];</td>
  </tr>

  <tr class="row-odd">
    <td>[gtf_engine. Name] </td>
    <td>Nom du moteur GTF</td>
    <td>$this->aObjects["oOrder"]->getGtfEngine()->aFields['name'];</td>
  </tr>

  <tr class="row-even">
    <td> [fme_engine.name]  </td>
    <td>Nom du moteur FME utilisé </td>
    <td>$this->aObjects["oOrder"]->getFmeEngine()->aFields['name'];</td>
  </tr>

  <tr class="row-odd">
    <td>[order.user.name]</td>
    <td> Nom du demandeur de traitement</td>
    <td>$properties['user.name']['value'] = $this->aObjects["oOrder"]->getUser()->aFields['name'];</td>
  </tr>

  <tr class="row-even">
    <td> [order.user_email] </td>
    <td>Adresse mail du demandeur de traitement </td>
    <td>$properties['user.email']['value'] = $this->aObjects["oOrder"]->getUser()->aFields['email'];</td>
  </tr>

  <tr class="row-odd">
    <td>[order.user.login]</td>
    <td> Compte de connexion du demandeur</td>
    <td>$properties['user.login']['value'] = $this->aObjects["oOrder"]->getUser()->aFields['login'];</td>
  </tr>

  <tr class="row-even">
    <td>[order.worksapce.category.name]</td>
    <td> Catégorie du traitement</td>
    <td>$properties['catgory.name']['value'] = $this->aObjects["oOrder"]->getWorkspace()->getCategory()->aFields['email'];</td>
  </tr>

  <tr class="row-odd">
    <td>[order.workspace.name]</td>
    <td> Nom du traitement</td>
    <td>$properties['order.workspace.name']['value'] = $this->aObjects["oOrder"]->getWorkspace()->aFields['name'];</td>
  </tr>

  <tr class="row-odd">
    <td>[worksapce.fmw_file]</td>
    <td> Nom du projet FME</td>
    <td>$properties['order.workspace.fmw_file']['value'] = $this->aObjects["oOrder"]->getWorkspace()->aFields['fmw_file'];</td>
  </tr>

</tbody>
</table>

</div>


![](../../images/icones/warning_small.png) *La balise [order.email_notifications] doit être insérée dans les champs CC et CCi de sorte à ce qu'une notification de traitement soit envoyée aux adresses mail définies dans le formulaire de demande de traitement dans le champ 'Envoyer une copie de l'e-mail à' :*

![](../../images/destinatairecc.png)

![](../../images/icones/warning_small.png) *Lorsque plusieurs destinataires doivent être en copie du mail de notification, séparer les adresses mail par un retour charriot.*

## Définition avancée

L'administrateur saisit directement le code du mail. Il peut, pour cela, utiliser le code généré via l'édition simple en cliquant sur le bouton Générer le code à partir de l'édition simple.
